
/*
 * This file was written by David Mazieres and Michael Kaminsky.  Its
 * contents is uncopyrighted and in the public domain.  Of course,
 * standards of academic honesty nonetheless prevent anyone in
 * research from falsely claiming credit for this work.
 */

%#include "sfsagent.h"
%#include "dhash.h"

enum cfsastat {
  CFSA_OK = 0,
  CFSA_NOKEY = 1
};

struct cfsa_signhead_arg {
  bigint keyhash;
  opaque serialized_head<>;
};

struct cfsa_signhead_resok {
  sfs_pubkey2 k;
  sfs_sig2 s;
};

union cfsa_signhead_res switch (cfsastat status) {
 case CFSA_OK:
    cfsa_signhead_resok resok;
 default:
    void;
};

program CFS_AGENTCTL_PROG {
	version CFS_AGENTCTL_VERS {
		void
		CFS_AGENTCTL_NULL (void) = 0;

		bool
		CFS_AGENTCTL_ADDKEY (sfs_addkey_arg) = 1;

		bool
		CFS_AGENTCTL_REMAUTH (sfs_remauth_arg) = 2;

		void
		CFS_AGENTCTL_REMALLKEYS (void) = 3;

		sfs_keylist
		CFS_AGENTCTL_DUMPKEYS (void) = 4;

		void
		CFS_AGENTCTL_CLRCERTPROGS (void) = 5;

		bool
		CFS_AGENTCTL_ADDCERTPROG (sfsagent_certprog) = 6;

		sfsagent_certprogs
		CFS_AGENTCTL_DUMPCERTPROGS (void) = 7;

		void
		CFS_AGENTCTL_CLRREVOKEPROGS (void) = 8;

		bool
		CFS_AGENTCTL_ADDREVOKEPROG (sfsagent_revokeprog) = 9;

		sfsagent_revokeprogs
		CFS_AGENTCTL_DUMPREVOKEPROGS (void) = 10;

		void
		CFS_AGENTCTL_SETNOREVOKE (sfsagent_norevoke_list) = 11;

		sfsagent_norevoke_list
		CFS_AGENTCTL_GETNOREVOKE (void) = 12;

		void
		CFS_AGENTCTL_SYMLINK (sfsagent_symlink_arg) = 13;

		void
		CFS_AGENTCTL_RESET (void) = 14;

		int
		CFS_AGENTCTL_FORWARD (sfs_hostname) = 15;

		void
		CFS_AGENTCTL_RNDSEED (sfsagent_seed) = 16;

		sfsagent_rex_res
		CFS_AGENTCTL_REX (sfsagent_rex_arg) = 17;

		rex_sessvec
		CFS_AGENTCTL_LISTSESS (void) = 18;

		bool
		CFS_AGENTCTL_KILLSESS (sfs_hostname) = 19;

		bool
		CFS_AGENTCTL_CLRCERTPROG_BYREALM (sfsauth_realm) = 20;

		bool
		CFS_AGENTCTL_ADDEXTAUTH (sfsagent_addextauth_arg) = 21;
		
		cfsa_signhead_res
		CFS_AGENTCTL_SIGNHEAD (cfsa_signhead_arg) = 22;
	} = 1;
} = 344428;  // same as AGENTCTL, a compatibility hack

