#ifndef __RANGES_H
#define __RANGES_H

#include "sfsmisc.h"
#include "list.h"
#include "rxx.h"

struct range {
  uint64 _start;
  uint64 _len;
  list_entry<range> _link;

  range (uint64 s, uint64 l) { _start = s; _len = l; }
};

class ranges {
private:
  list<range, &range::_link> _l;
  uint64 _size;

public:
  ranges (uint64 size = 0xffffffffffffffffULL);
  ~ranges ();
  void add (uint64, uint64);
  bool check (uint64, uint64);
  uint64 end ();
  bool gaps (callback<void, uint64, uint64>::ref cb);
  bool filled(uint64, uint64) const;
  bool has_next_gap(uint64, uint64&, uint64&) const;
};

#endif // __RANGES_H
