#!/usr/bin/perl -w

# Does readdir() work on huge directories?

use strict;

my $d = "bd$$";
mkdir($d, 0777) || die "bigdir.pl: mkdir $d: $!";

sub mkf {
    my($seq) = @_;
    my $base = "";
    my $len = rand() * 220;
    my $i;
    for($i = 0; $i < $len; $i++){
        $base .= "x";
    }
    $base .= "-" . $seq;
    return $base;
}

my @ll;
my $nf = 300;
my $i;
for($i = 0; $i < $nf; $i++){
    my $f = mkf($i);
    open(F, ">$d/$f");
    print F "$i\n";
    close(F);
    push(@ll, $f);
}

opendir(D, $d);
my @l;
my $f;
while($f = readdir(D)){
    if($f ne "." && $f ne ".."){
        push(@l, $f);
    }
}
closedir(D);

if($#l + 1 != $nf){
    printf(STDERR "bigdir.pl: saw %d files, wanted $nf\n", $#l + 1);
    quit(1);
}

@l = sort { $a cmp $b } @l;
@ll = sort { $a cmp $b } @ll;

for($i = 0; $i < $nf; $i++){
    if($l[$i] ne $ll[$i]){
        print STDERR "bigdir.pl oops $l[$i] $ll[$i]\n";
        quit(1);
    }
}

# OK!
quit(0);

sub quit {
    my($status) = @_;

    my $i;
    for($i = 0; $i <= $#l; $i++){
        unlink("$d/$l[$i]");
    }
    rmdir($d);

    exit($status);
}
