
#include "sfsmisc.h"
#include "crypt.h"

int
main (int argc, char **argv)
{
  if (argc != 2) {
    warnx << "usage: " << argv[0] << " key_file\n";
    return -1;
  }

  char *sk_file = argv[1];
  ptr < rabin_priv > sk;

  str key = file2wstr (sk_file);
  if (!key)
    fatal ("errors!\n");
  else if (!(sk = import_rabin_priv (key, NULL)))
    fatal ("errors!\n");

  char buf[1024];
  for (int j=0; j<1024; j++)
    buf[j] = (char)(j%256);
  str s(buf, 1024);

  struct timeval tv0, tv1;
  gettimeofday(&tv0, 0);
  for (int i=0; i<1000; i++)
    bigint k = sk->sign (s);
  gettimeofday(&tv1, 0);
  unsigned long long v = (tv1.tv_sec * 1000000 + tv1.tv_usec) -
                         (tv0.tv_sec * 1000000 + tv0.tv_usec);
  warn << "average: " << v/1000 << "\n";
  return 0;
}

